#include <bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

int N, J;
vector< vector<int> > strom;
vector<int> rodic;
vector<bool> done;

void dfs(int kde, int odkial = -1) {
    rodic[kde] = odkial;
    for (int kam : strom[kde]) if (kam != odkial) dfs(kam, kde);
}

long long pow2(int x) {
    long long odpoved = 1;
    while (x--) odpoved = (2*odpoved) % MOD;
    return odpoved;
}

int main() {
    cin >> N >> J;
    strom.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x, y;
        cin >> x >> y;
        strom[x].push_back(y); 
        strom[y].push_back(x);
    }

    rodic.resize(N, -1);
    dfs(J);

    done.resize(N, false);
    done[J] = true;
    long long odpoved = 0;
    while (true) {
        int najhlbsi_list = -1, max_krokov = 0;
        for (int n=0; n<N; ++n) if (n != J && strom[n].size() == 1u && !done[n]) {
            int kde=n, krokov=1;
            while (!done[rodic[kde]]) { kde=rodic[kde]; ++krokov; }
            if (krokov > max_krokov) { najhlbsi_list=n; max_krokov=krokov; }
        }
        if (najhlbsi_list == -1) break;
        odpoved += pow2(max_krokov) - 1;
        odpoved %= MOD;
        int kde = najhlbsi_list;
        while (true) {
            if (done[kde]) break;
            done[kde] = true;
            kde = rodic[kde];
        }
    }

    odpoved = (odpoved+1+MOD)%MOD;
    cout << odpoved << endl;
}
