#include <bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

int N, J;
vector< vector<int> > strom;
vector<int> rodic, hlbka, najhlbsi_syn;
long long odpoved;

void dfs(int kde, int odkial = -1) {
    rodic[kde] = odkial;
    for (int kam : strom[kde]) if (kam != odkial) {
        dfs(kam, kde);
        if (hlbka[kam] + 1 > hlbka[kde]) {
            hlbka[kde] = hlbka[kam] + 1;
            najhlbsi_syn[kde] = kam;
        }
    }
}

int main() {
    cin >> N >> J;
    strom.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x, y;
        cin >> x >> y;
        strom[x].push_back(y); 
        strom[y].push_back(x);
    }
    rodic.resize(N, -1);
    hlbka.resize(N, 0);
    najhlbsi_syn.resize(N, -1);
    dfs(J);
    vector<long long> bandasky(N, 1);
    bandasky[J] = 0;
    while (true) {
        bool zmena = false;
        for (int n=0; n<N; ++n) if (hlbka[n] > 0 && bandasky[n] > 0) {
            zmena = true;
            bandasky[ najhlbsi_syn[n] ] += 2*bandasky[n];
            bandasky[ najhlbsi_syn[n] ] %= MOD;
            bandasky[n] = 0;
        }
        if (!zmena) break;
    }
    cout << ((1+accumulate(bandasky.begin(),bandasky.end(),0LL))%MOD) << endl;
}
